#ifndef __TGA_LOADER__H__
#define __TGA_LOADER__H__

#include <GL/glew.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

//#include <GL/glut.h>

/* OpenGL texture info */
struct gl_texture
{
	GLsizei width;
	GLsizei height;

	GLenum format;
	GLint	internalFormat;
	GLuint id;

	GLubyte *texels;
};


#pragma pack(push, 1)
/* TGA header */
struct tga_header
{
	GLubyte id_lenght;          /* size of image id */
	GLubyte colormap_type;      /* 1 is has a colormap */
	GLubyte image_type;         /* compression type */

	short	cm_first_entry;       /* colormap origin */
	short	cm_length;            /* colormap length */
	GLubyte cm_size;            /* colormap size */

	short	x_origin;             /* bottom left x coord origin */
	short	y_origin;             /* bottom left y coord origin */

	short	width;                /* picture width (in pixels) */
	short	height;               /* picture height (in pixels) */

	GLubyte pixel_depth;        /* bits per pixel: 8, 16, 24 or 32 */
	GLubyte image_descriptor;   /* 24 bits = 0x00; 32 bits = 0x80 */
};
#pragma pack(pop)

int load_tga_texture (const char *filename, GLenum target);

#endif