#pragma once

#include <vector>

#include "l3DS.h"
#include <GL/glew.h>

class Sphere {
  
protected:
  std::vector<LTriangle>    _triangles;  /**< vertex indices */
  std::vector<LVector4>     _vertices;   /**< 3D positions */
  std::vector<LVector3>     _normalsV;   /**< 3D normals */
  std::vector<LVector3>     _tangentsV;  /**< 3D tangent to surface */
  std::vector<LVector2>		_texCoordsV; /**< 2D texture coordinates */

public:
  Sphere(float radius=1., int nPhi=20, int nTheta=40);
  unsigned short *getModelIndices();
  GLfloat *getModelVertices();
  int getModelNumIndices();
  GLfloat *getModelUV();
  GLfloat *getModelNormals();
  GLfloat *getModelTangents();
  void initAttrib(GLuint shaderProgramID);
};